## nxt-firmware 1.29-20120908+dfsg

=== debian/changelog ===
nxt-firmware (1.29-20120908+dfsg-7) unstable; urgency=medium

  * Remove references to RCX as it is not supported.

 -- Dominik George <nik@naturalnet.de>  Thu, 19 Jan 2017 16:11:05 +0100

nxt-firmware (1.29-20120908+dfsg-6) unstable; urgency=medium

  * Inject timestamp from changelog into build to make it reproducible.
    Thanks to Eduard Sanou for pointing out. (Closes: #849926)
  * debian/watch: added a fake site to explain about the current
    status of the original upstream homepage.

 -- Dominik George <nik@naturalnet.de>  Fri, 06 Jan 2017 16:44:52 +0100

nxt-firmware (1.29-20120908+dfsg-3) unstable; urgency=low

  * Move AppStream metadata to new location /usr/share/metainfo/.
  * Add myself as uploader.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 23 Dec 2016 08:05:10 +0000

nxt-firmware (1.29-20120908+dfsg-2) unstable; urgency=medium

  * Adjusded d/copyright reflecting issues discovered using debmake -k.

 -- Dominik George <nik@naturalnet.de>  Thu, 20 Oct 2016 12:00:34 +0000

nxt-firmware (1.29-20120908+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #736124)

 -- Dominik George <nik@naturalnet.de>  Wed, 19 Oct 2016 12:27:42 +0200
