=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ 

override_dh_auto_build:
	make -C AT91SAM7S256/SAM7S256/gcc

override_dh_auto_clean:
	make -C AT91SAM7S256/SAM7S256/gcc clean
