=== debian/watch ===
version=4
opts=dversionmangle=s/.*\+dfsg/0.No-Release/ \
https://people.debian.org/~eriberto/ FakeWatchNoUpstreamReleaseForThisPackage-(\d\S+)\.gz
