=== debian/changelog ===
nxt-firmware (1.29.2-1) unstable; urgency=medium

  * New upstream version 1.29.2
    - Dropped 0000-missing-read.patch and 1000-fixed-date-time.patch
      included upstream.
    - Dropped Debian specific nxt-update-firmware now provided by upstream.
  * Adjusted d/watch to check upstream gpg file signature too.
  * Added d/gbp.conf enforcing the use of pristine-tar.
  * Switched debhelper dependency to debhelper-compat.
  * Switched appstream metadata license back to MIT and adjusted d/copyright.
  * Changed Vcs-Git entry to canonical form.
  * Corrected typo in d/copyright.

 -- Petter Reinholdtsen <pere@debian.org>  Mon, 13 Feb 2023 22:22:01 +0100

nxt-firmware (1.29-20120908+dfsg-9) unstable; urgency=medium

  * Renamed fix-date-time.patch into new naming scheme.
  * Added override for lintians section suggestion.
  * Added simple upstream/metadata.
  * Flagged package as multi-arch foreign, as it contain no binaries.
  * Renamed appstream metadata id to use _ instead of - for
    compatibility with D-Bus.
  * Changed upstream contact on request from upstream.
  * Switched appstream metadata ID to reverse domain-name.
  * Changed appstream metadata license to match license in d/copyright.
  * Updated d/watch with new upstream location.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 30 Sep 2021 07:41:37 +0200

nxt-firmware (1.29-20120908+dfsg-8) unstable; urgency=medium

  [ Dominik George ]
  * Salsa migration.
    + Update VCS-URLs.

  [ Petter Reinholdtsen ]
  * Added 0000-missing-read.patch to fix build problem (undefined _read)
    (Closes: #954598).
  * Updated Standards-Version from 3.9.8 to 4.6.0.
  * Removed trailing space from d/rules.
  * Updated debhelper compat level from 9 to 13.
  * Removed obsolete lintian override no-upstream-changelog.
  * Updated lintian override name debian-watch-may-check-gpg-signature to
    debian-watch-does-not-check-gpg-signature.
  * Documented in d/control the build do not need root access.
  * Switched copyright format url to https.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 24 Sep 2021 16:56:14 +0200
