=== debian/control ===
--- 
+++ 
@@ -6,16 +6,18 @@
  Dominik George <nik@naturalnet.de>,
  Petter Reinholdtsen <pere@debian.org>,
 Build-Depends:
- debhelper (>= 9),
+ debhelper-compat (= 13),
  gcc-arm-none-eabi,
  libnewlib-arm-none-eabi,
-Standards-Version: 3.9.8
+Standards-Version: 4.6.0
 Homepage: http://nxt-firmware.ni.fr.eu.org/
-Vcs-Git: https://anonscm.debian.org/git/debian-lego/nxt-firmware.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-lego/nxt-firmware.git
+Vcs-Git: https://salsa.debian.org/debian-lego-team/nxt-firmware.git
+Vcs-Browser: https://salsa.debian.org/debian-lego-team/nxt-firmware
+Rules-Requires-Root: no
 
 Package: nxt-firmware
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends},
 Recommends:
