=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 %:
-	dh $@ 
+	dh $@
 
 override_dh_auto_build:
 	make -C AT91SAM7S256/SAM7S256/gcc
