=== debian/changelog ===
nxt-firmware (1.29.7-6) unstable; urgency=medium

  * Make autopkgtest work for both libnxt version 0.4 and 0.5.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Sun, 23 Feb 2025 10:59:01 +0100

nxt-firmware (1.29.7-5) unstable; urgency=medium

  * Update autopgktest for new libnxt version.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Fri, 14 Feb 2025 12:24:23 +0100

nxt-firmware (1.29.7-4) unstable; urgency=medium

  * Go back to using picolibc, remove patch.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Thu, 06 Feb 2025 17:43:45 +0100

nxt-firmware (1.29.7-3) unstable; urgency=medium

  * Temporarily revert to use newlib instead of picolibc.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Wed, 15 Jan 2025 19:22:22 +0100

nxt-firmware (1.29.7-2) unstable; urgency=medium

  * Tell blhc to ignore hardening rules for firmware.
  * Add autopkgtest.
  * Fix d/copyright, use https.
  * metainfo: restrict device ID to NXT brick while in bootloader mode.
  * Rename metainfo file to match its id.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Wed, 16 Oct 2024 14:56:27 +0200

nxt-firmware (1.29.7-1) unstable; urgency=medium

  [ Nicolas Schodet ]
  * New upstream version 1.29.7 (Closes: #1065665).
    - Update to follow new upstream directory structure.
    - Update build deps and copyright for new version.
  * Update standards version to 4.7.0, no changes needed.
  * Remove source lintian overrides now that releases are signed.
  * Update upstream signing key.
  * Fix and add lintian overrides.
  * Update debian/copyright for debian files.
  * Add myself as uploader.
  * Add homepage and developer to appstream metadata.

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Set field Upstream-Contact in debian/copyright.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Wed, 04 Sep 2024 21:55:50 +0200
