=== debian/control ===
--- 
+++ 
@@ -5,12 +5,14 @@
 Uploaders:
  Dominik George <nik@naturalnet.de>,
  Petter Reinholdtsen <pere@debian.org>,
+ Nicolas Schodet <nico@ni.fr.eu.org>,
 Build-Depends:
  debhelper-compat (= 13),
  gcc-arm-none-eabi,
- libnewlib-arm-none-eabi,
-Standards-Version: 4.6.0
-Homepage: http://nxt-firmware.ni.fr.eu.org/
+ picolibc-arm-none-eabi,
+ python3-pil,
+Standards-Version: 4.7.0
+Homepage: https://nxt-firmware.ni.fr.eu.org/
 Vcs-Git: https://salsa.debian.org/debian-lego-team/nxt-firmware.git
 Vcs-Browser: https://salsa.debian.org/debian-lego-team/nxt-firmware
 Rules-Requires-Root: no
