=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

execute_before_dh_auto_build:
	# No hardening for NXT firmware, tell blhc to ignore firmware build.
	@echo 'blhc: ignore-line-regexp: ^arm-none-eabi-.*'
	dh_auto_build
