=== debian/tests/control ===
Tests: nxt-not-found
Depends: @, libnxt
