=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://nxt-firmware.ni.fr.eu.org/releases/ .*/nxt-firmware-(\d\S+).tar.gz
